{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.EC2.Types.ExportEnvironment
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.EC2.Types.ExportEnvironment
  ( ExportEnvironment
      ( ..,
        ExportEnvironment_Citrix,
        ExportEnvironment_Microsoft,
        ExportEnvironment_Vmware
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import Amazonka.EC2.Internal
import qualified Amazonka.Prelude as Prelude

newtype ExportEnvironment = ExportEnvironment'
  { fromExportEnvironment ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern ExportEnvironment_Citrix :: ExportEnvironment
pattern ExportEnvironment_Citrix = ExportEnvironment' "citrix"

pattern ExportEnvironment_Microsoft :: ExportEnvironment
pattern ExportEnvironment_Microsoft = ExportEnvironment' "microsoft"

pattern ExportEnvironment_Vmware :: ExportEnvironment
pattern ExportEnvironment_Vmware = ExportEnvironment' "vmware"

{-# COMPLETE
  ExportEnvironment_Citrix,
  ExportEnvironment_Microsoft,
  ExportEnvironment_Vmware,
  ExportEnvironment'
  #-}
