{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.EC2.Types.IpAddressType
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.EC2.Types.IpAddressType
  ( IpAddressType
      ( ..,
        IpAddressType_Dualstack,
        IpAddressType_Ipv4,
        IpAddressType_Ipv6
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import Amazonka.EC2.Internal
import qualified Amazonka.Prelude as Prelude

newtype IpAddressType = IpAddressType'
  { fromIpAddressType ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern IpAddressType_Dualstack :: IpAddressType
pattern IpAddressType_Dualstack = IpAddressType' "dualstack"

pattern IpAddressType_Ipv4 :: IpAddressType
pattern IpAddressType_Ipv4 = IpAddressType' "ipv4"

pattern IpAddressType_Ipv6 :: IpAddressType
pattern IpAddressType_Ipv6 = IpAddressType' "ipv6"

{-# COMPLETE
  IpAddressType_Dualstack,
  IpAddressType_Ipv4,
  IpAddressType_Ipv6,
  IpAddressType'
  #-}
