{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.EC2.Types.ListingState
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.EC2.Types.ListingState
  ( ListingState
      ( ..,
        ListingState_Available,
        ListingState_Cancelled,
        ListingState_Pending,
        ListingState_Sold
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import Amazonka.EC2.Internal
import qualified Amazonka.Prelude as Prelude

newtype ListingState = ListingState'
  { fromListingState ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern ListingState_Available :: ListingState
pattern ListingState_Available = ListingState' "available"

pattern ListingState_Cancelled :: ListingState
pattern ListingState_Cancelled = ListingState' "cancelled"

pattern ListingState_Pending :: ListingState
pattern ListingState_Pending = ListingState' "pending"

pattern ListingState_Sold :: ListingState
pattern ListingState_Sold = ListingState' "sold"

{-# COMPLETE
  ListingState_Available,
  ListingState_Cancelled,
  ListingState_Pending,
  ListingState_Sold,
  ListingState'
  #-}
